#include <bits/stdc++.h>

using namespace std;

long long a[10000000];

int main()
{
	long long n,k;
	cin>>n>>k;
	long long r = 0;
	stack<long long> s;
	long long c;
	for(long long i =0;i<n;i++)
	{
		cin>>c;
		if(c == 0)
		{
			a[0]++;
		}
		else if(c<0)
		{
			a[((-2)*c-1)]++;
		}
		else a[2*c]++;
		
	}
	for(long long i = 0;i<2*n+3;i++)
	{
		if(a[i]>=k)
		{
			r++;
			if(a[i] % 2 == 0)
			{
				s.push(i/2);
			}
			else
			{
				s.push((i+1)/(-2));
			}
		}
	}
	cout<<r<<endl;
	while(!s.empty())
	{
		cout<<s.top()<<" ";
		s.pop();
	}
}